#include <amxmodx>
#include <amxmisc>

#define PLUGIN		"Sprite Smiles"
#define VERSION		"1.0"
#define AUTHOR		"AndrewZ"

#define MAX_SMILES	40

new	g_messages[ MAX_SMILES ][ 8 ],
	g_sprite[ MAX_SMILES ]
	
new pcv_mode


public plugin_precache()
{
	new configs[ 64 ], file[ 128 ]
	
	get_configsdir( configs, 63 )
	format( file, 127, "%s/sprite_smiles.ini", configs )
	
	if( file_exists( file ) )
	{
		new line, text[ 128 ], textsize, temp[ 128 ]
		while( read_file( file, line, text, 255, textsize ) )
		{
			parse( text, g_messages[ line ], 7, temp, 127 )
			g_sprite[ line ] = precache_model( temp )
			line ++
		}
	}
}

public plugin_init()
{
	register_plugin( PLUGIN, VERSION, AUTHOR )
	
	pcv_mode = register_cvar( "ss_mode", "1" )
	
	register_clcmd( "say", "hook_say" )
}

public hook_say( id )
{
	new mode = get_pcvar_num( pcv_mode )
	
	if( mode )
	{
		if( is_user_alive( id ) )
		{
			new said[ 192 ]
			read_args( said, 191 )
			remove_quotes( said )
			
			for( new i; i < sizeof( g_messages ); i ++ )
			{
				switch( mode )
				{
					case 1:
					{
						if( equal( said, g_messages[ i ] ) )
						{
							set_sprite( id, i )
						}
					}
					case 2:
					{
						if( contain( said, g_messages[ i ] ) != -1 )
						{
							set_sprite( id, i )
						}
					}
				}
			}
		}
	}
}

public set_sprite( id, i  )
{
	if( task_exists( id ) )
	{
		remove_sprite( id )
		remove_task( id )
	}
	
	message_begin( MSG_ALL, SVC_TEMPENTITY )
	write_byte( 124 )
	write_byte( id )
	write_coord( 45 )
	write_short( g_sprite[ i ] )
	write_short( 100 )
	message_end()
	
	set_task( 2.5, "remove_sprite", id )
}

public remove_sprite( id )
{
	message_begin( MSG_ALL, SVC_TEMPENTITY )
	write_byte( 125 )
	write_byte( id )
	message_end()
}